<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="客商性质" label-width="85px"  prop="name">
        <el-select
          v-model="queryParams.customerNature"
          placeholder="客商性质"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.PMS_SUPPLIER_NATURE)"
            :key="dict.id"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="供应商名称" label-width="85px"  prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入供应商名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="供应商分类" label-width="85px"  prop="classification">
        <el-select
          v-model="queryParams.classification"
          placeholder="供应商分类"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.SUPPLIER_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="公司类型" label-width="85px"  prop="type">
        <el-select
          v-model="queryParams.type"
          placeholder="公司类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.SUPPLIER_COMPANY_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="供应商性质" label-width="85px"  prop="nature">
        <el-select
          v-model="queryParams.nature"
          placeholder="供应商性质"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.SUPPLIER_NATURE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="社会信用代码" label-width="98px"  prop="creditCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.creditCode"-->
<!--          placeholder="请输入社会信用代码"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="状态"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.SUPPLIER_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="客商性质" align="center" prop="customerNature" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.PMS_SUPPLIER_NATURE" :value="scope.row.customerNature" />
        </template>
      </el-table-column>
      <el-table-column label="供应商编号" align="center" prop="code" />
      <el-table-column label="供应商名称" align="center" prop="name" />
<!--      <el-table-column label="供应商分类" align="center" prop="classification" >-->
<!--        <template #default="scope">-->
<!--          <dict-tag :type="DICT_TYPE.SUPPLIER_TYPE" :value="scope.row.classification" />-->
<!--        </template>-->
<!--      </el-table-column>-->
<!--      <el-table-column label="公司类型" align="center" prop="type" >-->
<!--        <template #default="scope">-->
<!--          <dict-tag :type="DICT_TYPE.SUPPLIER_COMPANY_TYPE" :value="scope.row.type" />-->
<!--        </template>-->
<!--      </el-table-column>-->
<!--      <el-table-column label="供应商性质" align="center" prop="nature" >-->
<!--        <template #default="scope">-->
<!--          <dict-tag :type="DICT_TYPE.SUPPLIER_NATURE" :value="scope.row.nature" />-->
<!--        </template>-->
<!--      </el-table-column>-->
<!--      <el-table-column label="社会信用代码" align="center" prop="creditCode" />-->
<!--      <el-table-column label="纳税人识别号" align="center" prop="tin" />-->
<!--      <el-table-column label="法人" align="center" prop="corporation" />-->
<!--      <el-table-column-->
<!--        label="审核状态"-->
<!--        align="center"-->
<!--        prop="auditStatus"-->
<!--      >-->
<!--        <template #default="scope">-->
<!--          <dict-tag :type="DICT_TYPE.CRM_AUDIT_STATUS" :value="scope.row.auditStatus" />-->
<!--        </template>-->
<!--      </el-table-column>-->
<!--      <el-table-column label="公司地址" align="center" prop="address" />-->
<!--      <el-table-column label="经营范围" align="center" prop="bizScope" />-->
<!--      <el-table-column label="注册资金(万元)" align="center" prop="registeredCapital" />-->
<!--      <el-table-column label="年营业额(万元)" align="center" prop="annualTurnove" />-->
<!--      <el-table-column label="公司规模" align="center" prop="size" >-->
<!--        <template #default="scope">-->
<!--          <dict-tag :type="DICT_TYPE.SUPPLIER_SIZE" :value="scope.row.size" />-->
<!--        </template>-->
<!--      </el-table-column>-->
      <!--
      <el-table-column label="状态" align="center" prop="status" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.SUPPLIER_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      -->
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <div class="flex items-center justify-center">
          <el-button link type="primary" @click="openDetail(scope.row.id)"><Icon icon="ep:view" />详情 </el-button>
          <el-dropdown
            @command="(command) => handleCommand(command, scope.row)"
            v-hasPermi="[
                    'system:user:delete',
                    'system:user:update-password',
                    'system:permission:assign-user-role'
                  ]"
          >
            <el-button type="primary" link><Icon icon="ep:d-arrow-right" /> 更多</el-button>
            <template #dropdown>
              <el-dropdown-menu>
                <el-dropdown-item
                  command="handleUpdate"
                >
                  <Icon icon="ep:edit" />编辑
                </el-dropdown-item>
                <el-dropdown-item
                  command="handleDelete"
                >
                  <Icon icon="ep:delete" />删除
                </el-dropdown-item>
                <el-dropdown-item
                  v-if="scope.row.status != 3"
                  command="handleClose"
                >
                  <Icon icon="ep:close" />关闭
                </el-dropdown-item>
              </el-dropdown-menu>
            </template>
          </el-dropdown>
          </div>
<!--          <el-button-->
<!--            link-->
<!--            type="primary"-->
<!--            @click="openForm('update', scope.row.id)"-->
<!--          >-->
<!--            编辑-->
<!--          </el-button>-->
<!--          <el-button-->
<!--            v-if="scope.row.auditStatus === 0"-->
<!--            link type="primary" @click="handleSubmit(scope.row)"> 提交审核 </el-button>-->
<!--          <el-button-->
<!--            link-->
<!--            type="danger"-->
<!--            @click="handleDelete(scope.row.id)"-->
<!--          >-->
<!--            删除-->
<!--          </el-button>-->
<!--          <el-button-->
<!--            link-->
<!--            type="danger"-->
<!--            @click="handleClose(scope.row.id)"-->
<!--          >-->
<!--            关闭-->
<!--          </el-button>-->
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <Form ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { Api, SupplierVO } from '@/api/supplier/base'
import Form from './Form.vue'
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";
import { useRoute, useRouter } from 'vue-router'
import { watch } from 'vue'
import * as ContractApi from "@/api/crm/contract";
import {checkPermi} from "@/utils/permission";
import * as UserApi from "@/api/system/user";
import {SupplierApi} from "@/api/erp/purchase/supplier";

const route = useRoute()
const router = useRouter() // 路由对象
// watch(route, (to, from) => {
//   router.go(0)
// })
/** 供应商主数据 列表 */
defineOptions({ name: 'Suppliers' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const { push } = useRouter() // 路由跳转
const loading = ref(true) // 列表的加载中
const list = ref<SupplierVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  customerNature: undefined,
  code: undefined,
  name: undefined,
  classification: undefined,
  type: undefined,
  nature: undefined,
  creditCode: undefined,
  tin: undefined,
  corporation: undefined,
  incorporationDate: [],
  address: undefined,
  bizScope: undefined,
  registeredCapital: undefined,
  annualTurnove: undefined,
  size: undefined,
  status: undefined,
  remark: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const handleCommand = (command: string, row: SupplierVO) => {
  switch (command) {
    case 'handleDelete':
      handleDelete(row.id)
      break
    case 'handleUpdate':
      openForm('update', row.id)
      break
    case 'handleSubmit':
      handleSubmit(row)
      break
    case 'handleClose':
      handleClose(row.id)
      break
    default:
      break
  }
}
/** 查看供应商详情 */
const openDetail = (id: number) => {
  push({ name: 'SupplierDetailInfo', params: { id } })
}
/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await Api.getPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type?:string,id?: number) => {
  // 修改
  if (typeof id === 'number') {
    push({ name: 'SupplierDetailEdit', params: { id } })
    return
  }
  // 新增
  push({ name: 'SupplierDetailAdd' })
}
/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await Api.delete(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
/** 供应商关闭按钮操作 */
const handleClose = async (id: number) => {
  try {
    // 关闭的二次确认
    await message.confirm(`您确定关闭该供应商吗？`)
    // 发起删除
    await Api.changeStatus(id, 3)
    message.success(t('关闭成功'))
    // 刷新列表
    await getList()
  } catch {}
}
/** 提交审核按钮操作 */
const handleSubmit = async (row: SupplierVO) => {
  try {
    // 提交审核的二次确认
    await message.confirm(`您确定提交【${row.name}】审核吗？`)
    // 提交审核
    await Api.submitForApproval(row.id)
    message.success('提交审核成功！')
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await Api.export(queryParams)
    download.excel(data, '供应商主数据.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
